#pragma once

#include "registers.hpp"
#include "system.hpp"
#include "i_displayDriver.hpp"
#include "rcc.hpp"





class LTDC	:	public I_DisplayDriver
{
	public:
		
		static constexpr uint32 c_layer_number = 2;
		
		
		
		
		
	private:
		
		static uint8 m_fps;
		static uint8 m_thread;
		
		s_displayData m_displayData;
		RectGraphic m_layer[c_layer_number];
		uint32 m_layerNumber;
		Color m_colorBackground;
		
		friend void ISR_LTDC();
		
		
		
		
		
	public:
		
		LTDC();
		feedback startup(RCC& rcc);
		feedback init(s_displayData displayData, RectGraphic* layer, uint32 numberOfLayer);
		
		
		
		feedback set_thread()																							override;
		uint16 get_wakeUpInterrupt()																			override;
		
		feedback start()																									override;
		feedback stop()																										override;
		feedback set_layerBuffer(uint32 layer, Color* buffer)							override;
		feedback clear(uint32 layer)																			override;
		feedback set_colorBackground(uint8 red, uint8 green, uint8 blue)	override;
		feedback set_pixel(Vec2& position, Color color, uint32 layer)			override;
		
		s_displayData& get_displayData()																	override;
		Vec2 get_displayDimensions()																			override;
		RectGraphic& get_layerData(uint32 layer)													override;
		uint32 get_numberOfLayers()																				override;
		uint32 get_fps()																									override;
		Color get_colorBackground()																				override;
};